//				Step28.cpp
//    (firststeps.narod.ru)
//			  (1999-2001)
//			      1999 .
//           3.07.2001

#include "afxwin.h"	  //   MFC
#include "afxext.h"	  //    
#include "resource.h" //  

class CMyDoc : public CDocument	 //  
{
protected: 
	CMyDoc();
	CString csDate;				            //   
	virtual BOOL OnNewDocument();		    //      New
	virtual void Serialize(CArchive& ar);	//   
	DECLARE_DYNCREATE(CMyDoc)
public:
	CString GetDate();			//  
	void SetString(CString s);	//  
	void OnAbout();				//    
private:
	DECLARE_MESSAGE_MAP();		//  
};

IMPLEMENT_DYNCREATE(CMyDoc,	CDocument)

BEGIN_MESSAGE_MAP(CMyDoc, CDocument)
 ON_COMMAND(ID_ABOUT,OnAbout)	//    
END_MESSAGE_MAP()

void CMyDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())	//  
	{
		ar << csDate;	// 
	}
	else
	{
		ar >> csDate;//  
		UpdateAllViews(NULL); //  
	}
}


BOOL  CMyDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument()) //     
		return FALSE;				//  
	csDate="Hello View - Doc";		//    
	return TRUE;
}

void CMyDoc::OnAbout()
{
	SetString("  ()");	//  
	UpdateAllViews(NULL);			//  
}

void CMyDoc::SetString(CString s)
{
	csDate=s;						//    
}



CMyDoc::CMyDoc()					
{
	TRACE("CMyDoc::CMyDoc()\n");	//    
}

CString CMyDoc::GetDate()
{
	return csDate;				// 
}

class CNewView : public CView		//    
{
protected: 
	CNewView();
	DECLARE_DYNCREATE(CNewView)
public:
	void OnDraw(CDC* pDC);
	CMyDoc* GetDocument();
};

CMyDoc* CNewView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMyDoc)));
	return (CMyDoc*)m_pDocument;
}

void CNewView::OnDraw(CDC* pDC)
{
	CMyDoc* tempDoc=GetDocument();
	pDC->SetTextColor(RGB(255,0,0));				//   
	pDC->TextOut(10,10,tempDoc->GetDate());			// 
}

IMPLEMENT_DYNCREATE(CNewView, CView)

CNewView::CNewView()
{
 
}


class CMyView : public CView	//  
{
protected: 
	CMyView();						
	CMyDoc* GetDocument();		//  
	afx_msg BOOL OnSetCursor( CWnd* pWnd, UINT nHitTest, UINT message );	//      .
	DECLARE_DYNCREATE(CMyView)	//      
		
public:
	virtual void OnDraw(CDC* pDC);
private:
	DECLARE_MESSAGE_MAP()		//   
};

BEGIN_MESSAGE_MAP(CMyView, CView)	
  ON_WM_SETCURSOR()					//  				
END_MESSAGE_MAP()

BOOL CMyView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
  ::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS)); //  ,    
  return TRUE;
}



CMyDoc* CMyView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMyDoc)));	//     
	return (CMyDoc*)m_pDocument;							//  .
}


void CMyView::OnDraw(CDC* pDC)	 
{
	CMyDoc* tempDoc=GetDocument();				//  
	pDC->TextOut(10,10,tempDoc->GetDate());		//     

}

IMPLEMENT_DYNCREATE(CMyView, CView)

CMyView::CMyView()					
{
}


class CMainFrame : public CFrameWnd	//   	
{
protected:							
	CMainFrame();					
	DECLARE_DYNCREATE(CMainFrame)	
public:
	virtual BOOL OnCreateClient( LPCREATESTRUCT lpcs, CCreateContext* pContext ); //  
	CSplitterWnd m_wndSplitter;													  // 

};


BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT lpcs, CCreateContext* pContext )
{

 ASSERT(m_wndSplitter.CreateStatic(this,1,2));					//  
 ASSERT(m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CMyView),	//   
       CSize(100,50),pContext));	
 ASSERT(m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CNewView),	//   
       CSize(100,50),pContext));
 SetActiveView((CView*)m_wndSplitter.GetPane(0,1));				//   .
 return TRUE;
}


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

CMainFrame::CMainFrame()				
{	
}



class CStep2App : public CWinApp	//  
{
public:
	CStep2App();					
	virtual BOOL InitInstance();
private:
	DECLARE_MESSAGE_MAP()		//     
};

BEGIN_MESSAGE_MAP(CStep2App, CWinApp)	
  ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)	//   New
  ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)	//   Open
END_MESSAGE_MAP()


BOOL CStep2App::InitInstance()						
{
	CSingleDocTemplate* pDocTemplate;	//  
	pDocTemplate = new CSingleDocTemplate(	       
		IDR_MAINFRAME,					//  		
		RUNTIME_CLASS(CMyDoc),			// 	 ----|
		RUNTIME_CLASS(CMainFrame),		//   ---|   .	
		RUNTIME_CLASS(CMyView));		// 	 ----|
	AddDocTemplate(pDocTemplate);		//  
	CCommandLineInfo cmdInfo;			//   
	ParseCommandLine(cmdInfo);			//   			
	if (!ProcessShellCommand(cmdInfo))	//    
		return FALSE;                   
    m_pMainWnd->ShowWindow(SW_SHOW);    //  		
	m_pMainWnd->UpdateWindow();			//    	
	return TRUE;								
}

CStep2App::CStep2App()		
{
}

CStep2App theApp;
